/*

  Program Bisection_example.cpp:
  computes the root of the equation: exp( x ) - 1.5 by using the bisection method.

*/

#include "Bisection.h"
#include <iostream>
#include <cmath>
using namespace std;


// Function f(x) to find the root

double f( double x )
{
  double ff = exp( x ) - 1.5;
  return( ff );
}


// Main program

int main()
{
  cout << "Solution of the equation: exp(x)-1.5 = 0 through the bisection method." << endl;

  double a, b, ak, bk, eps, root, width;
  int count = 0;

  // Initial parameters

  cout << "Initial interval [a,b]: ";
  cin >> a >> b;
  cout << "Precision in the computation of the root (eps): ";
  cin >> eps;

  // Invokes the function "bisection" to find the root

  ak = a;
  bk = b;
  bisection( f, &ak, &bk, &count, eps, 1 );
  
  root = 0.5 * ( ak + bk );
  width = abs( bk - ak );
  cout.precision( 15 );
  cout << "Root of the equation in: " << root << " +- " << 0.5 * width << endl;
  cout << "Value of the function in the root: " << f( root ) << endl;
  cout << "Total number of iterations: " << count << endl;
  cout << "Theoretical number of iterations: " << ceil( log( ( b - a ) / eps ) / log( 2.0 ) ) << endl;
}
