/*
  Program Newton_example.cpp:
  use the Newton method to find the root of the equation:
  f( x ) = exp( x ) - 1.5.
*/

#include "Newton.h"
#include <iostream>
#include <cmath>
#include <cstdlib>
using namespace std;


// Function f(x) to find the root of

double f( double x )
{
  double ff = exp( x ) - 1.5;
  return( ff );
}

/*
double f( double x )
{
  double pi = acos( -1.0 );
  double ff = x / ( 1.5 + sin( pi * x ) ) - 0.5;
  return( ff );
}
*/

double fp( double x )
{
  double ff = exp( x );
  return( ff );
}

/*
double fp( double x )
{
  double pi = acos( -1.0 );
  double ff = ( ( 1.5 + sin( pi * x ) ) - pi * x * cos( pi * x ) ) /
    ( ( 1.5 + sin( pi * x ) ) * ( 1.5 + sin( pi * x ) ) );
  return( ff );
}
*/

// Main program

int main()
{
  cout << "Solution of equation: exp(x)-1.5 = 0 through Newton's method." << endl;

  double a, b, xk, eps, width;
  int count, max_num_iter;

  // Initial parameters

  cout << "Insert the extrema of the interval [a,b]: ";
  cin >> a >> b;
  cout << "Initial guess for the zero (x0): ";
  cin >> xk;
  cout << "Maximum number of iterations: ";
  cin >> max_num_iter;
  cout << "Precision in the root evaluation (eps): ";
  cin >> eps;

  // Check on the initial interval

  if ( f( a ) * f( b ) > 0.0 )
    {
      cout << "Error! The interval [" << a << "," << b << "] does not contains a zero!" << endl;
      exit( 0 );
    }

  count = newton( f, fp, &xk, &width, max_num_iter, eps, 1 );
  
  if ( count < max_num_iter )
    {
      cout.precision( 15 );
      cout << "Root of the equation in: " << xk << " +- " << 0.5 * width << endl;
      cout << "Value of the function in the root: " << f( xk ) << endl;
      cout << "Number of iterations: " << count << endl;
    }
  else
    {
      cout << "The number of iterations exceeded the maximum number of iterations allowed: ";
      cout << max_num_iter << endl;
      cout << "Try a higher number of iterations or a different initial guess for the solution!" << endl;
    }
}
